/*
m_3d_place_source - place a source in a 3d room

DESCRIPTION

SYNTAX

INITIALIZATION

PERFORMANCE

CREDITS
Author: Jeanette C., thanks to Brian Carty author of the Csound HRTF opcodes.
*/

opcode m_3d_place_source, aa, akkkkkkki
	asrc, ksx, ksy, ksz, klx, kly, klz, kheadrot, iroomfn xin

	; Read basic room parameters
	irfade table 0, iroomfn, 0
	irorder table 1, iroomfn, 0
	irx table 2, iroomfn, 0
	iry table 3, iroomfn, 0
	irz table 4, iroomfn, 0
	irwallhi table 5, iroomfn, 0
	irwalllo table 6, iroomfn, 0
	irwallg1 table 7, iroomfn, 0
	irwallg2 table 8, iroomfn, 0
	irwallg3 table 9, iroomfn, 0
	irfloorhi table 10, iroomfn, 0
	irfloorlo table 11, iroomfn, 0
	irfloorg1 table 12, iroomfn, 0
	irfloorg2 table 13, iroomfn, 0
	irfloorg3 table 14, iroomfn, 0
	irceilhi table 15, iroomfn, 0
	irceillo table 16, iroomfn, 0
	irceilg1 table 17, iroomfn, 0
	irceilg2 table 18, iroomfn, 0
	irceilg3 table 19, iroomfn, 0
	Sleft sprintf "hrtf-%d-left.dat", sr
	Sright sprintf "hrtf-%d-right.dat", sr

	; Position the source in the room
	aleft, aright, irtl, irth, imfp hrtfearly asrc, ksx, ksy, ksz, klx, kly, klz, Sleft, Sright, 0, irfade, sr, irorder, 1, kheadrot, irx, iry, irz, irwallhi, irwalllo, irwallg1, irwallg2, irwallg3, irfloorhi, irfloorlo, irfloorg1, irfloorg2, irfloorg3, irceilhi, irceillo, irceilg1, irceilg2, irceilg3

	xout aleft, aright
endop
